/**************************
	Technorati Sidebar
	By Neo101
	Version 1.0.0
**************************/

var SECURITY_ID	= max_security_id
var PLUGIN_NAME = "Technorati Sidebar"

var alreadyShowingError	= false
window.onerror	= showErrorMessage

var SETTINGS_FILE = 'Settings.ini'
var DEFAULT_SETTINGS_FILE = 'DefaultSettings.ini'

var timer

var defaultCheck = 'enableInterval'


function showErrorMessage(message, url, line){
	var d 		= new Date()
	var date	= d.getHours()+':'+d.getMinutes()+':'+d.getSeconds()
	if(!alreadyShowingError)
		external.get_tab(SECURITY_ID, external.cur_sel).window.status 
				= 'Message: '+message+' Line: '+line+' URL: '+url+' Date: '+date
	alreadyShowingError	= true
}


function readFile(filename) {
	return external.readFile(SECURITY_ID,PLUGIN_NAME,filename)
}


function writeFile(filename,data) {
	external.writeFile(SECURITY_ID,PLUGIN_NAME,filename,data)
}


function readSetting(Key, errorResponse) {
	if(errorResponse == null) 
		errorResponse = ''
	var returnValue = readIni(SETTINGS_FILE,"Settings", Key, 'error')
	if(returnValue == 'error') {
		var defaultFileValue = readIni(DEFAULT_SETTINGS_FILE,"Settings", Key, 'error')
		if(defaultFileValue == 'error')
			return errorResponse
		else {
			writeSetting(Key, defaultFileValue)
			returnValue = defaultFileValue
		}
	}
	return returnValue
}


function checkSettingsFile(){
	if(readIni("settings.ini","Settings", defaultCheck, 'error') != 'error') return false
	var defaultSettingsFile = readFile('DefaultSettings.ini')
	if(defaultSettingsFile && defaultSettingsFile != '') 
		writeFile('Settings.ini', defaultSettingsFile)
	return true
}


function readIni(file, section, key, errorResponse){
	if(errorResponse == null) 
		errorResponse = ''
	return external.m2_readIni(SECURITY_ID, PLUGIN_NAME, file, section, key, errorResponse)
}


function writeIni(file, section, key, data) {
	external.m2_writeIni(SECURITY_ID, PLUGIN_NAME, file, section, key, data+'')
}


function writeSetting(key, data) {
	writeIni(SETTINGS_FILE,"Settings", key, data+'')
}


function showError(message){
	if(document.getElementById('message')){
		if(timer) clearTimeout(timer)
		document.getElementById('message').innerHTML = message
		document.getElementById('message').style.display = ''
		timer = window.setTimeout("document.getElementById('message').style.display = 'none'", 30000)
	}
	else{
		alert(message)
	}
}
